sidebarNodes={"extras":[{"group":"","headers":[{"anchor":"modules","id":"Modules"}],"id":"api-reference","title":"API Reference"},{"group":"","headers":[{"anchor":"dynamic-ecto-query-filtering-and-generic-queries","id":"Dynamic Ecto query filtering and generic queries"},{"anchor":"http-request-validation","id":"HTTP request validation"},{"anchor":"security-plugs","id":"Security plugs"},{"anchor":"test-helpers","id":"Test helpers"},{"anchor":"installation","id":"Installation"},{"anchor":"documentation","id":"Documentation"},{"anchor":"copyright-and-license","id":"Copyright and License"}],"id":"readme","title":"Phoenix API Toolkit"}],"modules":[{"group":"","id":"PhoenixApiToolkit.CacheBodyReader","nodeGroups":[{"key":"functions","name":"Functions","nodes":[{"anchor":"cache_and_read_body/2","id":"cache_and_read_body/2","title":"cache_and_read_body(conn, opts \\\\ [])"},{"anchor":"get_raw_request_body/1","id":"get_raw_request_body/1","title":"get_raw_request_body(conn)"}]}],"sections":[],"title":"PhoenixApiToolkit.CacheBodyReader"},{"group":"","id":"PhoenixApiToolkit.Ecto.DynamicFilters","nodeGroups":[{"key":"types","name":"Types","nodes":[{"anchor":"t:extra_filter_definitions/0","id":"extra_filter_definitions/0","title":"extra_filter_definitions()"},{"anchor":"t:filter/0","id":"filter/0","title":"filter()"},{"anchor":"t:filter_definition/0","id":"filter_definition/0","title":"filter_definition()"},{"anchor":"t:filter_definitions/0","id":"filter_definitions/0","title":"filter_definitions()"}]},{"key":"functions","name":"Functions","nodes":[{"anchor":"generate_filter_docs/2","id":"generate_filter_docs/2","title":"generate_filter_docs(filters, extras \\\\ [])"},{"anchor":"standard_filters/6","id":"standard_filters/6","title":"standard_filters(query, filters, default_binding, filter_definitions, resolve_binding, overrides \\\\ nil)"}]}],"sections":[{"anchor":"module-example-without-standard-filters","id":"Example without standard filters"},{"anchor":"module-example-with-standard-filters-and-autogenerated-docs","id":"Example with standard filters and autogenerated docs"},{"anchor":"module-generating-documentation","id":"Generating documentation"},{"anchor":"module-filter-key-types","id":"Filter key types"},{"anchor":"module-equal-to-filters","id":"Equal-to filters"},{"anchor":"module-equal-to-any-filters","id":"Equal-to-any filters"},{"anchor":"module-smaller-than-filters","id":"Smaller-than filters"},{"anchor":"module-greater-than-or-equal-to-filters","id":"Greater-than-or-equal-to filters"},{"anchor":"module-string-starts-with-filters","id":"String-starts-with filters"},{"anchor":"module-string-contains-filters","id":"String-contains filters"},{"anchor":"module-list-contains-filters","id":"List-contains filters"},{"anchor":"module-list-contains-any-filters","id":"List-contains-any filters"},{"anchor":"module-list-contains-all-filters","id":"List-contains-all filters"},{"anchor":"module-order-by-sorting","id":"Order-by sorting"},{"anchor":"module-limit-filter","id":"Limit filter"},{"anchor":"module-offset-filter","id":"Offset filter"},{"anchor":"module-filter-by-function-filters","id":"Filter-by-function filters"}],"title":"PhoenixApiToolkit.Ecto.DynamicFilters"},{"group":"","id":"PhoenixApiToolkit.Ecto.Validators","nodeGroups":[{"key":"functions","name":"Functions","nodes":[{"anchor":"default_change/3","id":"default_change/3","title":"default_change(changeset, field, value)"},{"anchor":"map_if_valid/3","id":"map_if_valid/3","title":"map_if_valid(changeset, then_do, else_do \\\\ & &1)"},{"anchor":"move_change/4","id":"move_change/4","title":"move_change(changeset, field, new_field, value_mapper \\\\ & &1)"},{"anchor":"multifield_apply/3","id":"multifield_apply/3","title":"multifield_apply(changeset, fields, function)"},{"anchor":"validate_ilike_safe/2","id":"validate_ilike_safe/2","title":"validate_ilike_safe(changeset, fields)"},{"anchor":"validate_order_by/2","id":"validate_order_by/2","title":"validate_order_by(changeset, orderable_fields)"},{"anchor":"validate_plaintext/2","id":"validate_plaintext/2","title":"validate_plaintext(changeset, fields)"},{"anchor":"validate_searchable/4","id":"validate_searchable/4","title":"validate_searchable(changeset, field, search_field, opts \\\\ [])"},{"anchor":"validate_upload/3","id":"validate_upload/3","title":"validate_upload(changeset, field, file_signature)"},{"anchor":"validate_upload/4","id":"validate_upload/4","title":"validate_upload(changeset, field, mime_field, file_sig_mime_map)"}]}],"sections":[{"anchor":"module-examples","id":"Examples"}],"title":"PhoenixApiToolkit.Ecto.Validators"},{"group":"","id":"PhoenixApiToolkit.GenericRequestValidator","nodeGroups":[{"key":"types","name":"Types","nodes":[{"anchor":"t:schema/0","id":"schema/0","title":"schema()"}]},{"key":"functions","name":"Functions","nodes":[{"anchor":"get_entity_fields/1","id":"get_entity_fields/1","title":"get_entity_fields(schema)"},{"anchor":"path_param/1","id":"path_param/1","title":"path_param(attrs)"},{"anchor":"query_order_by/3","id":"query_order_by/3","title":"query_order_by(changeset, attrs, orderables)"},{"anchor":"query_pagination/4","id":"query_pagination/4","title":"query_pagination(changeset, attrs, max_limit \\\\ 100, default_limit \\\\ 50)"},{"anchor":"resource_schema/2","id":"resource_schema/2","title":"resource_schema(extra_fields \\\\ %{}, comparables \\\\ %{})"}]}],"sections":[],"title":"PhoenixApiToolkit.GenericRequestValidator"},{"group":"","id":"PhoenixApiToolkit.Security.HmacPlug","sections":[{"anchor":"module-configuration-options","id":"Configuration options"},{"anchor":"module-request-body-format-example","id":"Request body format example"},{"anchor":"module-examples","id":"Examples"}],"title":"PhoenixApiToolkit.Security.HmacPlug"},{"group":"","id":"PhoenixApiToolkit.Security.Oauth2Plug","nodeGroups":[{"key":"functions","name":"Functions","nodes":[{"anchor":"process_jwks/1","id":"process_jwks/1","title":"process_jwks(jwks)"}]}],"sections":[{"anchor":"module-usage-example","id":"Usage example"},{"anchor":"module-results-examples","id":"Results examples"}],"title":"PhoenixApiToolkit.Security.Oauth2Plug"},{"group":"","id":"PhoenixApiToolkit.Security.Plugs","nodeGroups":[{"key":"functions","name":"Functions","nodes":[{"anchor":"ajax_csrf_protect/2","id":"ajax_csrf_protect/2","title":"ajax_csrf_protect(conn, arg2 \\\\ nil)"},{"anchor":"put_security_headers/2","id":"put_security_headers/2","title":"put_security_headers(conn, opts \\\\ [])"},{"anchor":"require_content_type/2","id":"require_content_type/2","title":"require_content_type(conn, arg2 \\\\ nil)"},{"anchor":"set_forwarded_ip/2","id":"set_forwarded_ip/2","title":"set_forwarded_ip(conn, opts \\\\ [])"},{"anchor":"verify_oauth2_aud/2","id":"verify_oauth2_aud/2","title":"verify_oauth2_aud(conn, exp_aud)"},{"anchor":"verify_oauth2_scope/2","id":"verify_oauth2_scope/2","title":"verify_oauth2_scope(conn, exp_scopes)"}]}],"sections":[],"title":"PhoenixApiToolkit.Security.Plugs"},{"group":"","id":"PhoenixApiToolkit.TestHelpers","nodeGroups":[{"key":"types","name":"Types","nodes":[{"anchor":"t:gen_jwt_defaults/0","id":"gen_jwt_defaults/0","title":"gen_jwt_defaults()"},{"anchor":"t:gen_jwt_opts/0","id":"gen_jwt_opts/0","title":"gen_jwt_opts()"}]},{"key":"functions","name":"Functions","nodes":[{"anchor":"application_json/1","id":"application_json/1","title":"application_json(conn)"},{"anchor":"clean_volatile_fields/1","id":"clean_volatile_fields/1","title":"clean_volatile_fields(data)"},{"anchor":"create_hmac_plug_body/4","id":"create_hmac_plug_body/4","title":"create_hmac_plug_body(path, method, contents \\\\ %{}, timestamp \\\\ DateTime.utc_now() |> DateTime.to_unix(:second))"},{"anchor":"gen_jwk/1","id":"gen_jwk/1","title":"gen_jwk(overrides \\\\ [])"},{"anchor":"gen_jws/1","id":"gen_jws/1","title":"gen_jws(overrides \\\\ [])"},{"anchor":"gen_jwt/2","id":"gen_jwt/2","title":"gen_jwt(defaults, overrides \\\\ [])"},{"anchor":"gen_payload/1","id":"gen_payload/1","title":"gen_payload(overrides \\\\ [])"},{"anchor":"put_ajax_csrf_header/1","id":"put_ajax_csrf_header/1","title":"put_ajax_csrf_header(conn)"},{"anchor":"put_hmac/3","id":"put_hmac/3","title":"put_hmac(conn, body, secret)"},{"anchor":"put_jwt/2","id":"put_jwt/2","title":"put_jwt(conn, jwt)"},{"anchor":"put_query_params/2","id":"put_query_params/2","title":"put_query_params(conn, params)"},{"anchor":"put_raw_body/2","id":"put_raw_body/2","title":"put_raw_body(conn, raw_body)"},{"anchor":"test_jwks/0","id":"test_jwks/0","title":"test_jwks()"},{"anchor":"to_string_map/1","id":"to_string_map/1","title":"to_string_map(map)"}]}],"sections":[],"title":"PhoenixApiToolkit.TestHelpers"},{"group":"Exceptions","id":"PhoenixApiToolkit.Security.AjaxCSRFError","sections":[],"title":"PhoenixApiToolkit.Security.AjaxCSRFError"},{"group":"Exceptions","id":"PhoenixApiToolkit.Security.HmacVerificationError","sections":[],"title":"PhoenixApiToolkit.Security.HmacVerificationError"},{"group":"Exceptions","id":"PhoenixApiToolkit.Security.MissingContentTypeError","sections":[],"title":"PhoenixApiToolkit.Security.MissingContentTypeError"},{"group":"Exceptions","id":"PhoenixApiToolkit.Security.Oauth2TokenVerificationError","sections":[],"title":"PhoenixApiToolkit.Security.Oauth2TokenVerificationError"}],"tasks":[]}